/*** Compute LOWER confidence bound for c ***/

proc Lconf(stat,confbelt,sig);

local cbelt, Nc, belt, i, slope, conf;

/* Select the appropriate confidence belt */

cbelt = seqa(-170,2,80) | seqa(-10,.25,121);
Nc = rows(cbelt);

belt = confbelt[.,200-sig];

/* Compute confidence bound */

i = 2;
do while (stat>belt[i]) and (i<Nc);
    i = i+1;
endo;

slope = (cbelt[i]-cbelt[i-1])/(belt[i]-belt[i-1]);
conf = cbelt[i-1]+slope*(stat-belt[i-1]);

retp(conf);

endp;
