/*** Compute UPPER confidence bound for c ***/

proc Uconf(stat,confbelt,sig);

local cbelt, Nc, belt, i, slope, conf;

/* Select the appropriate confidence belt */

cbelt = seqa(-170,2,80) | seqa(-10,.25,121);
Nc = rows(cbelt);

belt = confbelt[.,sig];

/* Compute confidence bound */

i = Nc-1;
do while (stat<belt[i]) and (i>1);
    i = i-1;
endo;

slope = (cbelt[i+1]-cbelt[i])/(belt[i+1]-belt[i]);
conf = cbelt[i]+slope*(stat-belt[i]);

retp(conf);

endp;
